# Create savings plan

Creates a recurring savings plan that automatically invests a fixed cash amount at a defined frequency.
Set `type` to `INSTRUMENT` to invest in a single instrument, or `PORTFOLIO` to distribute the investment across the account's portfolio allocation.

Endpoint: POST /savings_plans
Version: 1.136.0
Security: oauth-client-credentials

## Header parameters:

  - `idempotency-key` (string, required)
    A UUID to be used as an idempotency key.  This prevents a duplicate request from being replayed.
https://docs.upvest.co/documentation/concepts/api_concepts/idempotency

  - `upvest-client-id` (string, required)
    Your client ID, issued by Upvest. Identifies the client making the request. Universally Unique Identifier (UUID).

  - `Authorization` (string, required)
    Bearer (access) token from the OAuth flow with correct scopes.
https://datatracker.ietf.org/doc/html/rfc6750

  - `signature` (string, required)
    https://tools.ietf.org/id/draft-ietf-httpbis-message-signatures-01.html#name-the-signature-http-header

  - `signature-input` (string, required)
    https://tools.ietf.org/id/draft-ietf-httpbis-message-signatures-01.html#name-the-signature-input-http-he

  - `upvest-api-version` (string)
    Upvest API version (Note: Do not include quotation marks)

## Request fields (application/json):

  - `user_id` (string, required)
    Unique identifier of the user, as a UUID.

  - `account_id` (string, required)
    Account unique identifier.

  - `name` (string)
    Savings plan name

  - `type` (string, required)
    The type of savings plan must be "PORTFOLIO".

  - `cash_amount` (string, required)

  - `currency` (string, required)
    Alphabetic three-letter [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html) currency code.
* EUR - Euro
* GBP - Pound Sterling
    Enum: "EUR", "GBP"

  - `start_date` (string, required)
    First date of the savings plan execution in YYYY-MM-DD format.

  - `period` (string, required)
    Unit of time.
* WEEK -
* MONTH -
* YEAR -
    Enum: "WEEK", "MONTH", "YEAR"

  - `interval` (integer, required)
    Number of periods between executions

  - `type` (string, required)
    The type of savings plan must be "INSTRUMENT".

  - `instrument_id` (any)
    Instrument unique identifier.

  - `instrument_id_type` (string)
    The type of the ID used in the request.
* ISIN - International Securities Identification Number
* WKN - German securities identification code
    Enum: "ISIN", "WKN"

  - `fee_configuration` (array)
    Fee configuration for instrument-type savings plan executions. Specifies the transaction fee model to apply to each buy order placed on execution.

  - `fee_configuration.type` (string, required)
    Fee type
* TRANSACTION_FEE_BUY -
    Enum: "TRANSACTION_FEE_BUY"

  - `fee_configuration.transaction_fee_model_id` (string, required)
    Fee model unique identifier.

## Response 202 fields (application/json):

  - `id` (string, required)
    Universally Unique Identifier (UUID) of a savings plan.

  - `created_at` (string, required)
    Date and time when the resource was created. [RFC 3339-5](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6), [ISO8601 UTC](https://www.iso.org/iso-8601-date-and-time-format.html)

  - `updated_at` (string, required)
    Date and time when the resource was last updated. [RFC 3339-5](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6), [ISO8601 UTC](https://www.iso.org/iso-8601-date-and-time-format.html)

  - `user_id` (string, required)
    Unique identifier of the user, as a UUID.

  - `account_id` (string, required)
    Account unique identifier.

  - `name` (string)
    Savings plan name

  - `type` (string, required)
    Type of the Savings plan.
* PORTFOLIO -
* INSTRUMENT -
    Enum: "PORTFOLIO", "INSTRUMENT"

  - `instrument_id` (any)
    Instrument unique identifier.

  - `instrument_id_type` (string)
    The type of the ID used in the request.
* ISIN - International Securities Identification Number
* WKN - German securities identification code
    Enum: "ISIN", "WKN"

  - `cash_amount` (string, required)

  - `start_date` (string, required)
    First date of the savings plan execution in YYYY-MM-DD format.

  - `currency` (string, required)
    Alphabetic three-letter [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html) currency code.
* EUR - Euro
* GBP - Pound Sterling
    Enum: "EUR", "GBP"

  - `period` (string, required)
    Unit of time.
* WEEK -
* MONTH -
* YEAR -
    Enum: "WEEK", "MONTH", "YEAR"

  - `interval` (integer, required)
    Number of periods between executions

  - `status` (string)
    Status of a Savings Plan.
* ACTIVE -
* CANCELLED -
    Enum: "ACTIVE", "CANCELLED"

  - `fee_configuration` (array)
    Fee configuration for instrument-type savings plan executions. Specifies the transaction fee model to apply to each buy order placed on execution.

  - `fee_configuration.type` (string, required)
    Fee type
* TRANSACTION_FEE_BUY -
    Enum: "TRANSACTION_FEE_BUY"

  - `fee_configuration.transaction_fee_model_id` (string, required)
    Fee model unique identifier.

  - `cancellation_reason` (string)
    Explains the reason why the savings plan was cancelled .
* CANCELLED_BY_CLIENT: The savings plan was cancelled by the client.
* CANCELLED_BY_UPVEST: The savings plan was cancelled by Upvest.
    Enum: "CANCELLED_BY_CLIENT", "CANCELLED_BY_UPVEST"

  - `cancellation_details` (string)
    Additional details about the cancellation

## Response 400 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

## Response 401 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

## Response 403 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

## Response 404 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

## Response 405 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

## Response 406 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

## Response 429 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

## Response 500 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

## Response 503 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

## Response 504 fields (application/problem+json):

  - `type` (string, required)
    URL to a document describing the error condition.

  - `status` (integer, required)
    Transmission of the HTTP status code so that all information can be found in one place, but also to correct changes in the status code due to the use of proxy servers.

  - `title` (string)
    A short, human-readable title for the general error type; the title should not change for given types.

  - `detail` (string)
    A human-readable description of the specific error.

  - `instance` (string)
    This optional key may be present, with a unique URI for the specific error; this will often point to an error log for that specific response.

  - `request_id` (string)
    Correlation ID for the original request.

